Attribute VB_Name = "Core"
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Module:      Core - Core Module
'
'
'-----------------------------------------------------------------------
'
' responsible:  WolfgangA
'
' special area: SQLStudio
'
' description:  module for function imports, constants ...
'
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


Option Explicit

'--------------------------------------------------------
' Module Name
'--------------------------------------------------------
Const MODULE_NAME = "SQLStudio.Core"

'=public const=====================================

Public Type WINDOWPOS
    HWnd As Long
    hWndInsertAfter As Long
    x As Long
    y As Long
    cx As Long
    cy As Long
    flags As Long
End Type

Public Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type


'const used in funtion RemoveMenu
Public Const MF_BYPOSITION = &H400&
Public Const MF_REMOVE = &H1000&

Public Const SQL_NO_DATA = 100

Public Const SW_SHOWNORMAL = 1

Public Const ODBC_INSTALL_INQUIRY = 1
Public Const ODBC_INSTALL_COMPLETE = 2
Public Const ODBC_DRVR_NAME = "SQLSTUDIOODBC"

Public Const SQL_MAX_MESSAGE_LENGTH = 512

Public Const SQL_SUCCESS = 0
Public Const SQL_SUCCESS_WITH_INFO = 1

Public Const REMOVEFAILEDCON = "RemFailedCon"

Public Const NOTIMEOUT = "NoTimeOut"

Public Const STATUSWINDOW_HEIGTH = "Height"
Public Const CATALOG_WIDTH = "Width"
Public Const WINDOWPLACEMENT = "WindowPlacement"
Public Const STATUSWINDOW = "StatusWindow"
Public Const CATALOGMANAGER = "CatalogManager"
Public Const CATALOG_REGKEY = WINDOWPLACEMENT + "\" + CATALOGMANAGER
Public Const STATUSWINDOW_REGKEY = WINDOWPLACEMENT + "\" + STATUSWINDOW

Public Const WM_SYSCOMMAND = &H112
Public Const WM_CLOSE = &H10
Public Const WM_NCLBUTTONDOWN = &HA1
Public Const WM_ACTIVATE = &H6
Public Const WM_EXITSIZEMOVE = &H232
Public Const WM_MOVE = &H3

Public Const WA_INACTIVE = 0
Public Const WA_ACTIVE = 1
Public Const WA_CLICKACTIVE = 2

'Public Const WM_NCLBUTTONUP = &HA2
'Public Const WM_LBUTTONUP = &H202
Public Const WM_MOVING = &H216
Public Const WM_NCACTIVATE = &H86
Public Const GW_CHILD = 5
Public Const WM_NCLBUTTONDBLCLK = &HA3

'Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONDBLCLK = &H203
'Public Const WM_RBUTTONDOWN = &H204
'Public Const WM_RBUTTONUP = &H205
'Public Const WM_RBUTTONDBLCLK = &O206
'Public Const WM_MBUTTONDOWN = &H207
Public Const WM_PAINT = &HF
Public Const WM_ERASEBKGND = &H14
Public Const WM_SETFOCUS = &H7

Public Const WM_WINDOWPOSCHANGING = &H46
Public Const WM_WINDOWPOSCHANGED = &H47

Public Const RGN_XOR = 3
Public Const GWL_WNDPROC = (-4)
Public Const GWL_HINSTANCE = (-6)
Public Const GWL_HWNDPARENT = (-8)
Public Const GWL_ID = (-12)
Public Const GWL_STYLE = (-16)
Public Const GWL_EXSTYLE = (-20)
Public Const GWL_USERDATA = (-21)

Public Const SWP_NOSIZE = &H1
Public Const SWP_NOMOVE = &H2
Public Const WS_CHILD = &H40000000
Public Const WS_THICKFRAME = &H40000
Public Const WS_SYSMENU = &H80000
Public Const WS_CAPTION = &HC00000 'WS_BORDER Or WS_DLGFRAME

Public Const SW_NORMAL = 1
Public Const SW_SHOWMINIMIZED = 2
Public Const SW_SHOWMAXIMIZED = 3

'const path for help urls

Public Const hlpRoot = "SAP DB Library"

Public Const HID_STARTING_SQL_STUDIO = "ad990062eaf111d4aa2800a0c9430730"
Public Const HID_OPENING_A_DATABASE_SESSION = "ad990068eaf111d4aa2800a0c9430730"
Public Const HID_OPTIONS_FOR_CONNECTING_TO_THE_DATABASE = "ad99007eeaf111d4aa2800a0c9430730"
Public Const HID_RECENT_SESSIONS_LIST = "ad990082eaf111d4aa2800a0c9430730"
Public Const HID_LOGGING_OFF_FROM_THE_DATABASE = "ad99006beaf111d4aa2800a0c9430730"
Public Const HID_USER_SETTINGS = "ad99006eeaf111d4aa2800a0c9430730"
Public Const HID_CATALOG_MANAGER = "ad990072eaf111d4aa2800a0c9430730"
Public Const HID_SQL_STUDIO_OBJECTS = "ee1c5bdfeba711d4aa2800a0c9430730"
Public Const HID_TABLES = "ad99008beaf111d4aa2800a0c9430730"
Public Const HID_CREATING_A_DATABASE_TABLE = "ee1c5bcdeba711d4aa2800a0c9430730"
Public Const HID_DEFINING_COLUMNS = "ee1c5bd3eba711d4aa2800a0c9430730"
Public Const HID_DEFINING_CONSTRAINTS = "ee1c5bd6eba711d4aa2800a0c9430730"
Public Const HID_DEFINING_FOREIGN_KEY_DEPENDENCIES = "ee1c5bd9eba711d4aa2800a0c9430730"
Public Const HID_DEFINING_MISCELLANEOUS_INFORMATION = "ee1c5bdceba711d4aa2800a0c9430730"
Public Const HID_CREATING_A_VIEW_TABLE = "ee1c5be2eba711d4aa2800a0c9430730"
Public Const HID_CREATING_A_SYNONYM = "ee1c5be5eba711d4aa2800a0c9430730"
Public Const HID_DISPLAYING_THE_DEFINITION_OF_A_TABLE = "402197b6b8e811d6b29b00508b5d5c51"
Public Const HID_CHANGING_THE_DEFINITION_OF_A_DATABASE_TABLE = "ee1c5bd0eba711d4aa2800a0c9430730"
Public Const HID_DISPLAYING_THE_CONTENTS_OF_A_TABLE = "402197c0b8e811d6b29b00508b5d5c51"
Public Const HID_RENAMING_A_TABLE = "402197acb8e811d6b29b00508b5d5c51"
Public Const HID_DELETING_ALL_ROWS_OF_A_TABLE = "402197a2b8e811d6b29b00508b5d5c51"
Public Const HID_DELETING_A_TABLE = "40219798b8e811d6b29b00508b5d5c51"
Public Const HID_INDEXES = "ad99008eeaf111d4aa2800a0c9430730"
Public Const HID_CREATING_AN_INDEX = "cdadf27ab99711d6b2a300508b6b8a93"
Public Const HID_DISPLAYING_THE_DEFINITION_OF_AN_INDEX = "cdadf284b99711d6b2a300508b6b8a93"
Public Const HID_DELETING_AN_INDEX = "cdadf28eb99711d6b2a300508b6b8a93"
Public Const HID_NUMBER_SEQUENCES = "ad990091eaf111d4aa2800a0c9430730"
Public Const HID_CREATING_A_SEQUENCE = "cdadf298b99711d6b2a300508b6b8a93"
Public Const HID_DISPLAYING_THE_DEFINITION_OF_A_SEQUENCE = "cdadf2a2b99711d6b2a300508b6b8a93"
Public Const HID_DELETING_A_SEQUENCE = "cdadf2acb99711d6b2a300508b6b8a93"
Public Const HID_FAVORITES = "ad990094eaf111d4aa2800a0c9430730"
Public Const HID_USER = "ad990097eaf111d4aa2800a0c9430730"
Public Const HID_DATABASE_PROCEDURES = "da58913a594e3b12e10000000a114084"
Public Const HID_SQL_DIALOG = "ad990075eaf111d4aa2800a0c9430730"
Public Const HID_CREATING_SQL_STATEMENTS = "ee1c5beeeba711d4aa2800a0c9430730"
Public Const HID_KEYWORD_LIST = "0c847e85ba5811d6b29d00508b5d5211"
Public Const HID_SETTING_PARAMETERS_FOR_SQL_STATEMENTS = "ee1c5bebeba711d4aa2800a0c9430730"
Public Const HID_IMPORTING_AND_EXPORTING_SQL_STATEMENTS = "ad9900a3eaf111d4aa2800a0c9430730"
Public Const HID_EXECUTING_SQL_STATEMENTS = "ad99009deaf111d4aa2800a0c9430730"
Public Const HID_FORM_DIALOG = "ad990078eaf111d4aa2800a0c9430730"
Public Const HID_EXECUTING_A_FORM_DIALOG = "fdfc4b34ec5411d4aa2800a0c9430730"
Public Const HID_SELECTING_DATA_RECORDS_USING_SEARCH_CONDITIONS = "fdfc4b37ec5411d4aa2800a0c9430730"
Public Const HID_CHANGING_DATA_RECORDS = "fdfc4b3aec5411d4aa2800a0c9430730"
Public Const HID_INSERTING_DATA_RECORDS = "fdfc4b3dec5411d4aa2800a0c9430730"
Public Const HID_DELETING_A_DATA_RECORD = "fdfc4b40ec5411d4aa2800a0c9430730"
Public Const HID_IMPORTING_AND_EXPORTING_LONG_COLUMNS = "fdfc4b43ec5411d4aa2800a0c9430730"
Public Const HID_VISUAL_QUERY_DIALOG = "ad99007beaf111d4aa2800a0c9430730"
Public Const HID_CREATING_A_VISUAL_QUERY = "ad9900a9eaf111d4aa2800a0c9430730"
Public Const HID_LINKING_TABLE_COLUMNS_WITH_JOINS = "ad9900bbeaf111d4aa2800a0c9430730"
Public Const HID_ENTERING_SEARCH_CONDITIONS = "ad9900caeaf111d4aa2800a0c9430730"
Public Const HID_SETTING_PARAMETERS_FOR_SEARCH_CONDITIONS = "fdfc4b28ec5411d4aa2800a0c9430730"
Public Const HID_DEFINING_THE_RESULT_VIEW = "ad9900b8eaf111d4aa2800a0c9430730"
Public Const HID_EXECUTING_A_VISUAL_QUERY = "ad9900b2eaf111d4aa2800a0c9430730"
Public Const HID_RESULT_TABLES = "0c847e99ba5811d6b29d00508b5d5211"
Public Const HID_ADJUSTING_THE_RESULT_VIEW = "dd839214be4c11d6b2ab00508b6b8a93"
Public Const HID_SAVING_A_RESULT = "2913f76ebe7b11d6b2a200508b5d5c51"

Public Const HID_BOOK_OPTIMIZER = "fb36fe3b34334a7be10000000a114084"
Public Const HID_BOOK_WEB_TOOLS_INSTALLATION_GUIDE = "fe389e3a85166506e10000000a114084"
Public Const HID_BOOK_DATABASE_MANAGER_CLI = "14774939e5523668e10000000a114084"
Public Const HID_BOOK_SAP_DB_LOADER = "2dc6c63522b8057ce10000009b38f889"
Public Const HID_BOOK_EVALUATING_SYSTEM_TABLES = "35f8823cb7e5d42be10000000a114027"
Public Const HID_BOOK_DEVELOPMENT_ENVIRONMENT = "43c62c3a11f3bf31e10000000a11402f"
Public Const HID_BOOK_EXTERNAL_BACKUP_TOOLS = "43e0f23ab6b4317de10000000a11402f"
Public Const HID_BOOK_INSTALLATION_GUIDE = "4cda3b3c51bd4b3ae10000000a114084"
Public Const HID_BOOK_INSTALLATION_GUIDE_C_C_PRECOMPILER = "5fab013a251bd86de10000000a114084"
Public Const HID_BOOK_DATABASE_SOFTWARE_INSTALLATION_GUIDE = "7de0e17e60420b4ea28123288530d77b"
Public Const HID_BOOK_DATABASE_MANAGER_GUI = "7aea493905e6d07de10000000a114084"
Public Const HID_BOOK_ORACLE_SQL_MODE = "81ee4d3c596f0b26e10000000a11402f"
Public Const HID_BOOK_SQL_STUDIO = "9395dc3958923402e10000000a11402f"
Public Const HID_BOOK_USER_MANUAL = "97026b3ae886616ae10000000a114084"
Public Const HID_BOOK_ODBC_MANUAL = "a1f3733c04e67247e10000000a11402f"
Public Const HID_BOOK_MESSAGES = "bfe3c635d0998e4be10000009b38f839"
Public Const HID_BOOK_WEB_BASED_PROBLEM_TRACKING_SYSTEM = "cc79953cf4320b14e10000000a114084"
Public Const HID_BOOK_REFERENCE_MANUAL = "daed9036dfe4b903e10000009b38f889"
Public Const HID_BOOK_SAP_DB_LIBRARY = "e255683ab81fd846e10000000a11402f"
Public Const HID_BOOK_SOURCE_CODE_FOR_TOOLS = "f5cad23a97c94173e10000000a114084"
'===========================================================================

'=imported functions=====================================
Declare Function GetSystemMenu Lib "user32" (ByVal HWnd As Long, ByVal bRevert As Long) As Long
Declare Function GetMenuItemCount Lib "user32" (ByVal hMenu As Long) As Long
Declare Function DrawMenuBar Lib "user32" (ByVal HWnd As Long) As Long
Declare Function RemoveMenu Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long) As Long

Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long
Public Declare Function SetWindowRgn Lib "user32" (ByVal HWnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Public Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

Public Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long

Public Declare Function MoveWindow Lib "user32" (ByVal HWnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long

Public Declare Function UpdateWindow Lib "user32" (ByVal HWnd As Long) As Long

Public Declare Function GetWindow Lib "user32" (ByVal HWnd As Long, ByVal wCmd As Long) As Long

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal HWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Long) As Long

Public Declare Function DrawFocusRect Lib "user32" (ByVal hdc As Long, lpRect As RECT) As Long
Declare Function LockWindowUpdate Lib "user32" _
                                            (ByVal HWnd As Long) As Long
                                            
Declare Function SetActiveWindow Lib "User" (ByVal HWnd As Integer) As Integer
Declare Function GetActiveWindow Lib "User" () As Integer
    
Public Declare Function GetWindowRect Lib "user32" (ByVal HWnd As Long, lpRect As RECT) As Long

Public Declare Function ShowWindow Lib "user32" (ByVal HWnd As Long, _
                                                 ByVal nCmdShow As Long) As Long

    
Public Declare Function CallWindowProc Lib _
           "user32.dll" Alias "CallWindowProcA" ( _
                                                ByVal lpPrevWndFunc As Long, _
                                                ByVal HWnd As Long, _
                                                ByVal Msg As Long, _
                                                ByVal wParam As Long, _
                                                ByVal lParam As Long) As Long
                                                
Public Declare Sub CopyMemoryFromPointer Lib "kernel32" Alias _
    "RtlMoveMemory" (dest As Any, ByVal Source As Long, ByVal Length As Long)
                                                
                                                
    
Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" _
    (ByVal HWnd As Long, ByVal nIndex As Long) As Long
    
Public Declare Function SetWindowPos Lib "user32" (ByVal HWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
    
Public Declare Function SetWindowLong Lib _
                        "user32.dll" Alias "SetWindowLongA" ( _
                                ByVal HWnd As Long, _
                                ByVal nIndex As Long, _
                                ByVal dwNewLong As Long) As Long

''' Parameter Description for Shell Execute
'''
''' hwnd         Identifies the parent window. This window receives any
'''              message boxes an application produces (for example, for error
'''              reporting).
'''
''' lpszOp       Points to a null-terminated string specifying the operation
'''              to perform. This string can be "open" or "print." If this
'''              parameter is NULL, "open" is the default value.
'''
''' lpszFile     Points to a null-terminated string specifying the file
'''              to open.
'''
''' lpszParams   Points to a null-terminated string specifying parameters
'''              passed to the application when the lpszFile parameter
'''              specifies an executable file. If lpszFile points to a string
'''              specifying a document file, this parameter is NULL.
'''
''' LpszDir      Points to a null-terminated string specifying the default
'''              directory.
'''
''' FsShowCmd    Specifies whether the application window is to be shown when
'''              the application is opened.
'''Declare Function ShellExecuteA Lib "shell32.dll" _
'''                                            (ByVal HWnd As Long, _
'''                                             ByVal lpszOp As String, _
'''                                             ByVal lpszFile As String, _
'''                                             ByVal lpszParams As String, _
'''                                             ByVal LpszDir As String, _
'''                                             ByVal FsShowCmd As Long) _
'''                                             As Long
'''
'''Declare Function ShellExecuteW Lib "shell32.dll" _
'''                                            (ByVal HWnd As Long, _
'''                                             ByVal lpszOp As String, _
'''                                             ByVal lpszFile As String, _
'''                                             ByVal lpszParams As String, _
'''                                             ByVal LpszDir As String, _
'''                                             ByVal FsShowCmd As Long) _
'''                                             As Long
                                            

'The GetWindowThreadProcessId function retrieves the identifier of the
'thread that created the specified window and, optionally,
'the identifier of the process that created the window.
Public Declare Function GetWindowThreadProcessId Lib "user32" _
                            (ByVal HWnd As Long, _
                             lpdwprocessid As Long) As Long

'===========================================================================
